"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var firebase = _interopRequireWildcard(require("firebase/app"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * 
 * @param {FirebaseProduct} product 
 */
var loadFirebaseModule = function loadFirebaseModule(product) {
  switch (product) {
    case 'auth':
      return require('firebase/auth');

    case 'database':
      return require('firebase/database');

    case 'firestore':
      return require('firebase/firestore');

    case 'functions':
      return require('firebase/functions');

    case 'messaging':
      return require('firebase/messaging');

    case 'storage':
      return require('firebase/storage');
  }
};

var Firebase =
/**
 * 
 * @param {FirebaseConfig} config - Firebase Configuration options
 * @param {FirebaseProduct[]} products - Firebase Products to initialise
 */
function Firebase(config) {
  var _this = this;

  var products = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  _classCallCheck(this, Firebase);

  products.forEach(loadFirebaseModule); // Initialise app if needed

  if (!firebase.apps.length) firebase.initializeApp(config); // Construct services

  this.app = firebase.app;
  products.forEach(function (moduleName) {
    // Require the specific product
    var firebaseProduct = firebase[moduleName];
    _this[moduleName] = firebaseProduct; // Initialise as capitalised if appropriate

    if (typeof firebaseProduct === "function") {
      _this[_lodash["default"].capitalize(moduleName)] = firebaseProduct();
    }
  });
};

var _default = Firebase;
exports["default"] = _default;