"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _FirebaseContext = _interopRequireDefault(require("../../FirebaseContext"));

var _Firebase = _interopRequireDefault(require("../../Firebase"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * Creates a Firebase Provider
 * 
 * @param {FirebaseConfig} config - Configuration options for Firebase
 * @param {FirebaseProduct[]} products - Array of Firebase Products to initialise
 */
function useFirebaseProvider(config, products) {
  var _React$useState = _react["default"].useState(new _Firebase["default"](config, products)),
      _React$useState2 = _slicedToArray(_React$useState, 1),
      firebase = _React$useState2[0];

  function FirebaseProvider(_ref) {
    var children = _ref.children;
    return _react["default"].createElement(_FirebaseContext["default"].Provider, {
      value: firebase
    }, children);
  }

  return _react["default"].useCallback(FirebaseProvider, [firebase]);
}

var _default = useFirebaseProvider;
exports["default"] = _default;